var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React from 'react';
var FinisherComponent = /** @class */ (function (_super) {
    __extends(FinisherComponent, _super);
    function FinisherComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FinisherComponent.prototype.render = function () {
        return null;
    };
    FinisherComponent.prototype.componentDidMount = function () {
        var _a = this.props, finishStep = _a.finishStep, result = _a.result;
        finishStep(result);
    };
    return FinisherComponent;
}(React.Component));
export default (function (context) { return function (_a) {
    if (_a === void 0) { _a = { step: undefined }; }
    var step = _a.step, hocProps = __rest(_a, ["step"]);
    return function (WrapperComponent) { return function (props) {
        return (React.createElement(context.Consumer, null, function (_a) {
            var finishStep = _a.finishStep, currentStep = _a.currentStep;
            var isCurrentStep = currentStep === step;
            var finishStepFunction = function (result) {
                if (!step || isCurrentStep) {
                    finishStep(currentStep, result);
                }
            };
            var Finisher = function (_a) {
                var result = _a.result;
                return (React.createElement(FinisherComponent, { result: result, finishStep: finishStepFunction }));
            };
            return (React.createElement(WrapperComponent, __assign({ isCurrentStep: isCurrentStep, currentStep: currentStep, finishStep: finishStepFunction, Finisher: Finisher, step: step }, props, hocProps)));
        }));
    }; };
}; });
//# sourceMappingURL=createWithAlgorithm.js.map