var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
export default (function (context) {
    return /** @class */ (function (_super) {
        __extends(AlgorithmProvider, _super);
        function AlgorithmProvider(props) {
            var _this = _super.call(this, props) || this;
            _this.finishStep = function (step, result) {
                var currentStep = _this.props.algorithm(step, result);
                _this.setState({
                    currentStep: currentStep
                });
            };
            _this.state = {
                currentStep: props.initialStep
            };
            return _this;
        }
        AlgorithmProvider.prototype.render = function () {
            var currentStep = this.state.currentStep;
            return (React.createElement(context.Provider, { value: {
                    currentStep: currentStep,
                    finishStep: this.finishStep
                } }, this.props.children));
        };
        return AlgorithmProvider;
    }(React.Component));
});
//# sourceMappingURL=createAlgorithmProvider.js.map