import React from 'react';
import { AlgorithmContext } from './types';
declare type HOCProps = {
    step?: string;
    [key: string]: any;
};
declare type FinisherWrapperProps = {
    result: any;
};
export declare type WrappedComponentProps = {
    isCurrentStep: boolean;
    currentStep: string | undefined;
    finishStep: any;
    step: string | undefined;
    Finisher: React.SFC<FinisherWrapperProps>;
};
declare const _default: (context: React.Context<AlgorithmContext>) => <T extends any>({ step, ...hocProps }?: HOCProps) => (WrapperComponent: React.ComponentClass<WrappedComponentProps, any> | React.StatelessComponent<WrappedComponentProps>) => (props: T) => JSX.Element;
export default _default;
